/* Homework 2 Problem 4
 *
 * Count the number of times SW0 is moved to the "1" position,
 * and display this on the red LEDs.
 *
 * Sometimes the count goes up by more than 1 when
 * you move the switch.  Why do you think this happens?
 */

.include "ubc-de1media-macros.s"

.equ		SW0mask,	0x01

.global	_start

.text
_start:		movia	r23, IOBASE
		movi	r4, 0

loop:

/* wait for SW1 to go from 1 to 0 */
while1:		ldwio	r3, SWITCH(r23)
		andi	r3, r3, SW0mask
		bne	r3, r0, while1	/* wait while SW0=1 */

/* wait for SW0 to go from 0 to 1 */
while0:		ldwio	r3, SWITCH(r23)
		andi	r3, r3, SW0mask
		beq	r3, r0, while0	/* wait while SW0=0 */

increment:	addi	r4, r4, 1
		stwio	r4, LEDR(r23)

		br	loop

.end
